# dcforumlib.pl
#
# Part of DCForum Version 6 Release 23 by DCScripts
# Feb 22, 2002
# Copyright  1997-2002 DCScripts All Rights Reserved
#
# Modification History
# mod.2002.02.14.03
# private forum bug
# mod.2002.02.14.01
# No access if the forum status if OFF
# mod.2001.10.30.01
# private forum security patch
# mod.2001.0828.02 - Multiple mark in the lobby bug
# MOD.2001.08.08.01
# Also return session ID
# mod.2001.06.22.04 - POLL
# mod.2001.06.22.02 - logout.pl hack
# mod.2001.06.15.01 - Restricted forum hack
# mod.2001.04.01.01 - check input parameters
# mod.2000.11.16.01 - Private forum access bug
# mod.2000.11.08.01 - Fixes mark conference bug
# mod.2000.11.06.01 - allow marking each conference
# mod.2000.10.04.01 - Email to moderators for moderated forum
# mod.2000.09.22.01 - Jump to forum bug fix
# mod.2000.09.17.01 - get rid of background color in menu
# mod.2000.05.24.01 - Fixes blank space in username problem
#                     when marking forums
# mod.2000.05.23.02 - New filelock implemented
# mod.2000.05.23.01 - Fixes file upload bug for NT servers
# mod.2000.05.19.01 - added MARK ALL option in the lobby
#
# As part of the installation process, you will be asked
# to accept the terms of Agreement outlined in the readme.txt
# included with this distribution. This Agreement is
# a legal contract, which specifies the terms of the license
# and warranty limitation between you and DCScripts.
# You should carefully read this terms agreement before
# installing or using this software.  Unless you have a different license
# agreement obtained from DCScripts, installation or use of this software
# indicates your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of this software
#
#                                                                      #
#======================================================================#
#======================================================================#
# create_button                                                        #
# creates navigation menu button                                       #
#======================================================================#

sub create_button {

   my ($r_in,$r_setup) = @_;
   my $menu_buttons;
   my $l_buttons;
   my @l_buttons;
   my $separator = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';

   my $icon_desc;

   my $bgcolor = $r_setup->{'bg_color_5'};
   my $f_color = $r_setup->{'font_color_5'};
   my $f_face = $r_setup->{'font_face_5'};
   my $f_size = $r_setup->{'font_size_5'};

   my %b;

   my $user = $r_in->{'userdata'}->{'Username'};
   my $encoded_user = url_encode($r_in->{'userdata'}->{'Username'});

   if ($r_setup->{'use_icons'} eq "on") {
      $b{'profile'} = "<a href=\"$boardurl?az=user_profiles\"><img
            src=\"$imgurl/profile.gif\" alt=\"Click here to list user profiles\" border=\"0\" align=\"bottom\"></a>";
      $b{'rating'} = "<a href=\"$boardurl?az=view_user_ratings\"><img
            src=\"$imgurl/user_rating.gif\" alt=\"Click here to view user feedback/ratings\" border=\"0\" align=\"bottom\"></a>";
      $b{'read_new'} = "<a href=\"$boardurl?az=n_mesg&mode=new\"><img
            src=\"$imgurl/read_new.gif\"  alt=\"Click here to list all topics containing new messages\" border=\"0\" align=\"bottom\"></a>";
      $b{'back'} = "<a href=\"javascript:history.back()\"><img
            src=\"$imgurl/goback.gif\"  alt=\"Click here to go back to the previous page\" border=\"0\" align=\"bottom\"></a>";
      $b{'topics'} = "<a href=\"$boardurl?az=list&forum=$r_in->{'forum'}\"><img
            src=\"$imgurl/home.gif\"  alt=\"Click here to go to the forum listing\" border=\"0\" align=\"bottom\"></a>";
      $b{'login'} = "<a href=\"$boardurl?az=login\"><img 
            src=\"$imgurl/login.gif\"  alt=\"Click here to Login\" border=\"0\"></a>";
      $b{'post'} = "<a href=\"$boardurl?az=post&forum=$r_in->{'forum'}\"><img 
            src=\"$imgurl/post.gif\"  alt=\"Click here to post a topic and start a new discussion\" border=\"0\" align=\"bottom\"></a>";
      $b{'poll'} = "<a href=\"$boardurl?az=poll&forum=$r_in->{'forum'}\"><img 
            src=\"$imgurl/poll.gif\"  alt=\"Click here to post a new poll\" border=\"0\" align=\"bottom\"></a>";
      $b{'help'} = "<a href=\"$boardurl?az=help\"><img 
            src=\"$imgurl/help.gif\"  alt=\"Click here to see help\" border=\"0\" align=\"bottom\"></a>";
      $b{'search'} = "<a href=\"$boardurl?az=search&mode=new&s_conf=$r_in->{'conf'}&s_forum=$r_in->{'forum'}\"><img 
            src=\"$imgurl/search.gif\" alt=\"Click here to Search the Forum\" border=\"0\" align=\"bottom\"></a>";
      $b{'admin'} = "<a href=\"$adminurl\"><img 
            src=\"$imgurl/admin.gif\"  alt=\"Click here to go to administration page\" border=\"0\" align=\"bottom\"></a>";
      $b{'user'} = "<a href=\"$boardurl?az=user\"><img 
            src=\"$imgurl/user.gif\"  alt=\"Click here to go to user utility\" border=\"0\" align=\"bottom\"></a>";
      $b{'forum_subscribe'} = "<a href=\"$boardurl?az=user&command=forum_subscription\"><img 
            src=\"$imgurl/subscribe.gif\"  alt=\"Click here to subscribe to forums\" border=\"0\" align=\"bottom\"></a>";
      $b{'mark'} = "<a href=\"$boardurl?az=mark&forum=$r_in->{'forum'}\"><img 
        src=\"$imgurl/mark.gif\" alt=\"Click here to Mark this conference as Read\" border=\"0\" align=\"bottom\"></a>";
      if ($user) {
         $b{'login'} = "<a href=\"$boardurl?az=logout\"><img 
               src=\"$imgurl/logout.gif\"  alt=\"Click here to Logout\" border=\"0\" align=\"bottom\"></a>";
      }

   }
   
   if ($flag_status{$r_setup->{'use_text'}}) {
      $b{'profile'} .= qq~&nbsp;<a href="$boardurl?az=user_profiles"><font 
                  size="$f_size" face="$f_face" color="$f_color">Profiles</font></a>&nbsp;~;
      $b{'rating'} .= qq~&nbsp;<a href="$boardurl?az=view_user_ratings"><font 
                  size="$f_size" face="$f_face" color="$f_color">Ratings</font></a> ~;
      $b{'read_new'} .= qq~&nbsp;<a href="$boardurl?az=n_mesg&mode=new"><font 
                  size="$f_size" face="$f_face" color="$f_color">Read&nbsp;New</font></a>&nbsp;~;
      $b{'back'} .= qq~&nbsp;<a href="javascript:history.back()"><font 
                  size="$f_size" face="$f_face" color="$f_color">Go back</font></a>&nbsp;~;
      $b{'forum_subscribe'} .= qq~&nbsp;<a href="$boardurl?az=user&command=forum_subscription"><font 
                  size="$f_size" face="$f_face" color="$f_color">Subscribe</font></a>&nbsp;~;
      $b{'poll'} .= qq~&nbsp;<a href="$boardurl?az=poll&forum=$r_in->{'forum'}"><font 
                  size="$f_size" face="$f_face" color="$f_color">Poll</font></a>&nbsp;~;
      $b{'post'} .= qq~&nbsp;<a href="$boardurl?az=post&forum=$r_in->{'forum'}"><font 
                  size="$f_size" face="$f_face" color="$f_color">Post</font></a>&nbsp;~;
      $b{'help'} .= qq~&nbsp;<a href="$boardurl?az=help"><font 
                  size="$f_size" face="$f_face" color="$f_color">FAQ</font></a>&nbsp;~;
      $b{'search'} .= qq~&nbsp;<a href="$boardurl?az=search&mode=new&s_conf=$r_in->{'conf'}&s_forum=$r_in->{'forum'}"><font 
                  size="$f_size" face="$f_face" color="$f_color">Search</font></a>&nbsp;~;
      $b{'topics'} .= qq~&nbsp;<a href="$boardurl?az=list&forum=$r_in->{'forum'}"><font 
                  size="$f_size" face="$f_face" color="$f_color">Topics</font></a>&nbsp;~;
      $b{'admin'} .= qq~&nbsp;<a href="$adminurl"><font 
                  size="$f_size" face="$f_face" color="$f_color">Admin</font></a>&nbsp;~;
      $b{'user'} .= qq~&nbsp;<a href="$boardurl?az=user"><font 
                  size="$f_size" face="$f_face" color="$f_color">User Menu</font></a>&nbsp;~;
      $b{'mark'} .= qq~&nbsp;<a href=\"$boardurl?az=mark&forum=$r_in->{'forum'}\"><font 
            size="$f_size" face="$f_face" color="$f_color">Mark</font></a>&nbsp;~;
      if ($user) {
         $b{'login'} .= qq~&nbsp;<a href="$boardurl?az=logout"><font 
                  size="$f_size" face="$f_face" color="$f_color">Logout</font></a>&nbsp;~;
      }
      else {
         $b{'login'} .= qq~&nbsp;<a href="$boardurl?az=login"><font 
                  size="$f_size" face="$f_face" color="$f_color">Login</font></a>&nbsp;~;
      }
   }
   
   if ($r_in->{'az'} eq 'lobby') {
      # mod.2001.0828.02
      # Multiple mark in the lobby bug
      $b{'mark'} = ''; # reset button
      if ($r_in->{'conf'}) {
         if ($r_setup->{'use_icons'} eq "on") {
            $b{'mark'} = "<a href=\"$boardurl?az=mark&forum=all&conf=$r_in->{'conf'}\"><img 
              src=\"$imgurl/mark.gif\" alt=\"Click here to Mark this conference as Read\" border=\"0\" align=\"bottom\"></a>";
         }
         if ($r_setup->{'use_text'} eq "on") {
            $b{'mark'} .= qq~&nbsp;<a href=\"$boardurl?az=mark&forum=all&conf=$r_in->{'conf'}\"><font 
                  size="$f_size" face="$f_face" color="$f_color">Mark</font></a>&nbsp;~;
         }

      }
		else {
         if ($r_setup->{'use_icons'} eq "on") {
            $b{'mark'} = "<a href=\"$boardurl?az=mark&forum=all\"><img 
              src=\"$imgurl/mark.gif\" alt=\"Click here to Mark all the forums Read\" border=\"0\" align=\"bottom\"></a>";
         }

         if ($r_setup->{'use_text'} eq "on") {
            $b{'mark'} .= qq~&nbsp;<a href=\"$boardurl?az=mark&forum=all\"><font 
               size="$f_size" face="$f_face" color="$f_color">Mark All</font></a>&nbsp;~;
         }
		}
   }
   elsif ($r_in->{'az'} eq 'n_mesg') {
      if ($r_setup->{'use_icons'} eq "on") {
         $b{'mark'} = "<a href=\"$boardurl?az=mark&forum=all\"><img 
           src=\"$imgurl/mark.gif\" alt=\"Click here to Mark all the forums Read\" border=\"0\" align=\"bottom\"></a>";
      }

      if ($r_setup->{'use_text'} eq "on") {
         $b{'mark'} .= qq~&nbsp;<a href=\"$boardurl?az=mark&forum=all\"><font 
            size="$f_size" face="$f_face" color="$f_color">Mark All</font></a>&nbsp;~;
      }
   }

   my %page = (
      'lobby' => ['login','help','search','read_new','mark','user','profile','rating','admin'],
      'fully_threaded_list' => ['login','help','search','post','poll','mark','user','profile','rating','forum_subscription','admin'],
      'list' => ['login','help','search','post','poll','mark','user','profile','rating','forum_subscription','admin'],
      'search' => ['back','login','help','user','profile','rating','admin'],
      'help' => ['back','login','user','profile','rating','admin'],
      'n_mesg' => ['back','login','help','mark','user','profile','rating','admin'],
      'email_to_friend' => ['back','help','admin'],
      'user' => ['back','login','help','profile','rating','admin'],
      'user_profiles' => ['back','login','help','user','rating','admin'],
      'view_user_ratings' => ['back','login','help','user','profile','admin']
   );

   unless ($user) {
      $b{'profile'} = '';
      $b{'rating'} = '';
      $b{'forum_subscribe'} = '';
      $b{'mark'} = '';
      $b{'admin'} = '';
      $b{'user'} = '';
      unless ($flag_status{$r_setup->{'allow_polls'}}) {
         $b{'poll'} = '';
      }
      if ($flag_status{$r_setup->{'deny_poll_everyone'}}) {
         $b{'poll'} = '';
      }
   }   
   else {
      $b{'mark'} = '' unless (-e "$logdir/$encoded_user.log");
      $b{'rating'} = '' unless ($flag_status{$r_setup->{'user_rating'}});
      $b{'forum_subscribe'} = '' unless ($flag_status{$r_setup->{'subscription'}});
      unless ($r_in->{'userdata'}->{'Group'} eq "admin" or 
         $r_in->{'userdata'}->{'Group'} eq "moderator") {
         $b{'admin'} = '';
         unless ($flag_status{$r_setup->{'allow_polls'}}) {
            $b{'poll'} = '';
         }
      }
   }   

   if ($page{$r_in->{'az'}}) {
      foreach (@{$page{$r_in->{'az'}}}) {
         if ($b{$_}) {
            push(@l_buttons,$b{$_});
         }
      }
   }
   else {
      push(@l_buttons,$b{'back'},$b{'help'},$b{'admin'});
   }

   $menu_buttons = qq~<table border="0" cellspacing="0" 
   cellpadding="0" bgcolor="$bgcolor" align="left"><tr>~;
   foreach (@l_buttons ) {
      $menu_buttons .= qq~<td align="center" nowrap>$_&nbsp;&nbsp;</td>~;
   }
   if ($icon_desc) {
      $menu_buttons .= qq~<td align="left" nowrap>$icon_desc</td>~;
   }
   $menu_buttons .= qq~</tr></table>~;

  $menu_buttons;
}

#======================================================================#
# get_table_heading                                                    #
# Generates table heading for the lobby and mian listing               #
#======================================================================#

sub get_table_heading {

   my $text = shift;
   my $table_heading;
   
   $table_heading = qq~
      <TR BGCOLOR="$r_setup->{'bg_color_0'}">
         <TD ALIGN="CENTER">$text&nbsp;</TD>
         <TD ALIGN="CENTER" WIDTH="300"><a 
            href="$boardurl?az=set_sort_index&field=$subject_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Discussion Topic</font></a></TD>
         <TD ALIGN="CENTER"><a 
            href="$boardurl?az=set_sort_index&field=$author_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Author</font></a></TD>
            
         <TD ALIGN="CENTER" nowrap><a 
            href="$boardurl?az=set_sort_index&field=$date_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Last&nbsp;Updated&nbsp;Date/Author</font></a></TD>~;

      $table_heading .= qq~
         <TD ALIGN="CENTER"><a 
            href="$boardurl?az=set_sort_index&field=$replies_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Replies</font></a></TD>~;

      if ($r_setup->{'read_count'} eq 'on') {
         $table_heading .= qq~
         <TD ALIGN="CENTER"><a 
            href="$boardurl?az=set_sort_index&field=$view_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Views</font></a></TD>~;
      }

      if ($r_setup->{'topic_rating'} eq 'on') {
         $table_heading .= qq~
         <TD ALIGN="CENTER" WIDTH="50"><a 
            href="$boardurl?az=set_sort_index&field=$rating_index"><font 
            SIZE="$r_setup->{'font_size_0'}" FACE="$r_setup->{'font_face_0'}" 
            color="$r_setup->{'font_color_0'}">Rating</font></a></TD>~;
      }

      $table_heading .= "</TR>\n";

   return $table_heading;

}

#======================================================================#
# get_setup_variables                                                  #
# Read in forum setup variables and assign to output hash              #
#======================================================================#

sub get_setup_variables {
   my $datafile = shift;
   my $r_local = {};
   my $r_rows = readdata("$datafile");
   foreach (@{$r_rows}) {
      chomp;
      my ($key,$value) = split /$split_delim/;
      $r_local->{$key} = $value;
   }
   return $r_local;

}

#======================================================================#
# forum_links                                                          #
# Generats HTML text for the forum links drop down menu                #
# mod.2000.09.22.01 - Jump to forum bug fix
#======================================================================#

sub forum_links {

   my ($r_in,$r_setup) = @_;
   my $r_conf = readdata("$password_file_dir/$conf_file");
   my $r_conf_forums = {};
   my $r_conf_count = {};
   my $html_forum_links;

# mod.2001.10.30.01
# private forum security patch
   foreach (@{$r_setup->{'forums'}}) {
       # mod.2000.11.16.01
       # Private forum access bug
       if ($r_in->{'az'} eq 'a_mesg' or
          $r_in->{'az'} eq 'e_mesg' or
          $r_in->{'az'} eq 'admin_update_threads' or
          $r_in->{'az'} eq 'vote' or
          $r_in->{'az'} eq 'e_poll') {

          # mod.2001.06.15.01
          # Restricted forum hack
             unless (private($r_setup->{'forum_type'}->{$_})) {
                push( @{ $r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} } , $_);
                $r_conf_count->{$r_setup->{'forum_conf'}->{$_}}++;
          }
       }
       else {
          if ($r_setup->{'forum_status'}->{$_} eq "on" and
              check_forum_access($r_in,$r_setup,$_) ) {
                 push( @{ $r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} } , $_);
                 $r_conf_count->{$r_setup->{'forum_conf'}->{$_}}++;
          }
       }
    }

   # Some javascript stuff for drop and jump effect
   $html_forum_links = qq~
<script language="javascript">
function MakeArray() {
   this.length = MakeArray.arguments.length
   for (var i = 0; i < this.length; i++)
   this[i+1] = MakeArray.arguments[i]
}

var url = new MakeArray("","$boardurl",\n~;

   foreach (@{$r_conf}) {
      chomp;
      my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /$split_delim/;
      if ($r_conf_count->{$conf_id}) {
         $html_forum_links .= "\"$boardurl?conf=$conf_id\",\n";
         foreach (@{ $r_conf_forums->{$conf_id} }) {
               $html_forum_links .= "\"$boardurl?az=list&forum=$_\",\n";
         }
      }
   }

   chomp($html_forum_links);
   chop($html_forum_links);

   $html_forum_links .= qq~
   )
</script>


<FORM ACTION="$boardurl" METHOD="POST">
<input type="hidden" name="az" value="jump">
<TABLE BORDER="0" WIDTH="$r_setup->{'table_width'}" CELLPADDING="3" cellspacing="1">
<TR><TD ALIGN="RIGHT" VALIGN="TOP"><select name="forum" onChange="jumpPage(this.form)">
<option value="$boardurl?az=lobby">Select another forum or conference
<option value="$boardurl?az=lobby">Lobby
~;

   # mod.2000.09.22.01 - Jump to forum bug fix
   foreach (@{$r_conf}) {
      chomp;
      my ($conf_id,$conf_name,$conf_desc,$conf_status) = split /$split_delim/;
      if ($r_conf_count->{$conf_id} and $r_setup->{'conf_status'}->{$conf_id} eq 'on') {
         $html_forum_links .= "<option value=\"$boardurl?conf=$conf_id\">$conf_name (Conference)";
         foreach (@{ $r_conf_forums->{$conf_id} }) {
            $html_forum_links .= qq~
            <option value="$boardurl?az=list&forum=$_">&nbsp;&nbsp;\|--$r_setup->{'forum_name'}->{$_} ($r_setup->{'forum_type'}->{$_})
            ~;
         }
      }
   }
   $html_forum_links .= qq~</select><input type="submit" value="GO!"></TD></TR></TABLE></form>~;
}

#======================================================================#
# get_user_mark                                                        #
# Gets user time mark data from $logdir/username.log file              #
#======================================================================#

sub get_user_mark {

   my ($r_in, $r_setup) = @_;
   my $r_user_mark = {};
   if ($r_in->{'userdata'}->{'Username'}) {
      # mod.2000.05.24.01
      my $user_file;
      my $encoded_name = url_encode($r_in->{'userdata'}->{'Username'});
      $user_file = "$logdir/$encoded_name\.log";
      if (-e $user_file) {
         my $r_rows = readdata($user_file);
         foreach (@{$r_rows}) {
            chomp;
            my ($forum_name,$lastread) = split /=/;
            $r_user_mark->{$forum_name} = $lastread;
         }#End of foreach
         return $r_user_mark;
      }
      return 0;
   }#End of if ($username)...
   return 0;
}

#======================================================================#
# access_error                                                         #
# Generates error reporting for various access_error conditions        #
#======================================================================#

sub access_error {

   my ($error,$r_in,$r_setup) = @_;
   my $html_output;
   if ($error eq 'forum off') {
      $html_output = qq~"$r_setup->{'forum_name'}->{$r_in->{'forum'}}"
         forum is currently off-line<br>
         Please contact your webmaster for more information~;
   }
   elsif ($error eq 'forum private') {
      $html_output = qq~Forum Access Denied
      <br>&nbsp;&nbsp;<br>
      You  do not have access to "$r_setup->{'forum_name'}->{$r_in->{'forum'}}" forum.<br>
      To obtain access, please contact the forum administrator.
      ~;
   }
   elsif ($error eq 'remote posting') {
       $html_output = qq~ERROR: Remote posting not allowed.~;
   }
   
   $html_output = sub_heading($html_output,$r_setup) if ($html_output);

   return $html_output;
}

#======================================================================#
# check_forum_access                                                   #
# Checks to see if the user has access to the forum                    #
#======================================================================#

sub check_forum_access {

   my ($r_in,$r_setup,$forum) = @_; 
   my $access = "1";

# mod.2002.02.14.01
# No access if the forum status if OFF
   if ($r_setup->{'forum_status'}->{$forum} eq 'off') {
      return 0;
   }
   
   if ($r_setup->{'forum_type'}->{$forum} eq 'Private') {
      if ($r_setup->{'hide_private'} ne "on" 
		   and $r_in->{'az'} eq 'lobby') {
         $access = 1;
      }
      elsif ($r_setup->{'hide_private'} eq "on"
		   and $r_in->{'az'} eq 'admin_update_threads' ) {
         $access = 0;
      }
      else {
		   if (! defined($r_in->{'userdata'}->{'Username'}) ) {
			   $access = 0;
				return $access;
			}
# mod.2002.02.14.03
# private forum bug
#                  or $r_in->{'userdata'}->{'Forums'} =~ /$forum/ ) {
         unless ( $r_in->{'userdata'}->{'Group'} eq "admin"
                  or is_moderator($r_in->{'userdata'}->{'Username'},$r_setup->{'forum_owner'}->{$forum})
                  or $r_in->{'userdata'}->{'Forums'} =~ /\b$forum\b/ ) {
            $access = 0;
         }
      }
   }

   # mod.2001.06.15.01 - Restricted forum hack
   if ($r_setup->{'forum_type'}->{$forum} eq 'Restricted') {
      if ($r_setup->{'hide_private'} ne "on" 
		   and $r_in->{'az'} eq 'lobby') {
         $access = 1;
      }
      else {
		   if (! defined($r_in->{'userdata'}->{'Username'}) ) {
			   $access = 0;
				return $access;
			}
         if ( $r_in->{'userdata'}->{'Group'} eq "normal") {
            $access = 0;
         }
      }
   }

   return $access;

}


#======================================================================#
# initialize                                                           #
# Read in forum setup parameters                                       #
# Also reads in forum and conf information                             #
#======================================================================#

sub initialize {
   my $r_setup = {};
   $r_setup = get_setup_variables("$password_file_dir/$board_setup_file");
   get_conf_info("$password_file_dir/$conf_file",$r_setup);
   get_forum_info("$password_file_dir/$forum_file",$r_setup);
   return $r_setup;
}

#======================================================================#
# get_conf_info                                                        #
# Gets conference information from conf_info.txt and assigns it to     #
# $r_setup->{}-{confs} hash tree                                       #
#======================================================================#

sub get_conf_info {
   my($conf_file,$r_setup) = @_;
   my $r_lines = readdata($conf_file);
   foreach (@{$r_lines}) {                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
      chomp;
      my @temp = split /$split_delim/;
      push(@{$r_setup->{'conf'}},$temp[0]);
      $r_setup->{'conf_name'}->{$temp[0]} = $temp[1];
      $r_setup->{'conf_desc'}->{$temp[0]} = $temp[2];
      $r_setup->{'conf_status'}->{$temp[0]} = $temp[3];
   }
}

#======================================================================#
# save_conf_info                                                       #
# Save conference info to conf_info.txt file                           #
#======================================================================#

sub save_conf_info {

   my ($conf_file,$r_setup) = @_;
   my @new_row;

   foreach (@{$r_setup->{'conf'}}) {
      my $temp = join("$join_delim",
      $_,
      $r_setup->{'conf_name'}->{$_},
      $r_setup->{'conf_desc'}->{$_},
      $r_setup->{'conf_status'}->{$_} );
      push(@new_row,"$temp\n");
   }

   writedata($conf_file,\@new_row);

}


#======================================================================#
# get_forum_info                                                       #
# Gets forum information from forum_info.txt and assigns to            #
# $r_setup->{}-{forum} hash tree                                       #
#======================================================================#

sub get_forum_info {

   my($forum_file,$r_setup) = @_;
   my $r_lines = readdata($forum_file);
   foreach (@{$r_lines}) {
      chomp;
      my @temp = split /$split_delim/;
      push(@{$r_setup->{'forums'}},$temp[0]);
      $r_setup->{'forum_conf'}->{$temp[0]} = $temp[1];
      $r_setup->{'forum_name'}->{$temp[0]} = $temp[2];
      $r_setup->{'forum_desc'}->{$temp[0]} = $temp[3];
      $r_setup->{'forum_owner'}->{$temp[0]} = $temp[4];
      $r_setup->{'forum_owner_email'}->{$temp[0]} = $temp[5];
      $r_setup->{'forum_type'}->{$temp[0]} = $temp[6];
      $r_setup->{'forum_status'}->{$temp[0]} = $temp[7];
      $r_setup->{'forum_last'}->{$temp[0]} = $temp[8];
      $r_setup->{'forum_queue'}->{$temp[0]} = $temp[9];
      $r_setup->{'forum_threads'}->{$temp[0]} = $temp[10];
      $r_setup->{'forum_posts'}->{$temp[0]} = $temp[11];
      $r_setup->{'forum_archive'}->{$temp[0]} = $temp[12];
   }
}  

#======================================================================#
# save_forum_info                                                      #
# Save the forum information to forum_info.txt                         #
#======================================================================#

sub save_forum_info {

   my ($forum_file,$r_setup) = @_;
   my @new_row;

   foreach (@{$r_setup->{'forums'}}) {
         my $temp = join("$join_delim",
         $_,
         $r_setup->{'forum_conf'}->{$_},
         $r_setup->{'forum_name'}->{$_},
         $r_setup->{'forum_desc'}->{$_},
         $r_setup->{'forum_owner'}->{$_},
         $r_setup->{'forum_owner_email'}->{$_},
         $r_setup->{'forum_type'}->{$_},
         $r_setup->{'forum_status'}->{$_},
         $r_setup->{'forum_last'}->{$_},
         $r_setup->{'forum_queue'}->{$_},
         $r_setup->{'forum_threads'}->{$_},
         $r_setup->{'forum_posts'}->{$_},
         $r_setup->{'forum_archive'}->{$_} );
      push(@new_row,"$temp\n");
   }

   writedata($forum_file,\@new_row);

}

#======================================================================#
# get_team_members                                                     #
# Gets list of team members                                            #
#======================================================================#

# mod.2001.08.01 - multi-icon hack
sub get_team_members {
   my $team_file = shift;
   my $r_team = [];
   my %team_list;
   if (-e "$team_file") {
      $r_team = readdata("$team_file");
   }
# mod.2001.08.01 - multi-icon hack
   chomp(@{$r_team});
   foreach (@{$r_team}) {
      my ($user,$team) = split /$split_delim/;
      $user = lc($user);
      $team_list{$user} = $team;
   }
   return \%team_list;
}

#======================================================================#
# check_new                                                            #
# Checks to see if the input messages is a new message                 #
# $ltime & $date is the message date.  User date is in $user_mark      #
#======================================================================#

sub check_new {

    my ($ltime,$date,$user_mark) = @_;
    my ($hh,$minute,$second) = split(/\:/, $ltime);
    $second = 0 unless ($second);
    my ($mmonth,$dd,$yy) = split(/\//, $date);
    my $last_mesg = compute_time($yy, $mmonth, $dd, $hh, $minute, $second);
    if ($last_mesg > $user_mark) {
       return 1;
    }
    else {
       return 0;
    }

}

#======================================================================#
# check_team                                                           #
# Compares the input string $name to the list of team members          #
# in $team string.  If a memeber, it appends $team_name -              #
# which is a global variable defined in dcforum.setup                  #
#======================================================================#
# mod.2001.08.01.01
# Multi team hack
sub check_team {

   my $name = shift;
   my $r_team = shift;
   my $temp_name = lc($name);
   if ($r_team->{$temp_name}) {
      my $key = $r_team->{$temp_name} . '_icon';
      $name .= "<img src=\"$imgurl/$r_setup->{$key}\" alt=\"$r_team->{$temp_name}\">";
   }
   return $name;

}

####################################################################
# function is_guest
# Returns 1 if guest
####################################################################

sub is_guest {

   my $name = shift;

   if ($name =~ /Guest/) {
      return 1;
   }
   return 0;
}

#======================================================================#
# navigation_menu                                                      #
# Depending on the input action az, this function                      #
# generates the navigation menu                                        #
#======================================================================#
# mod.20001.07.22.01
# Cleaned up menu code

sub navigation_menu {

   my ($r_in,$r_setup) = @_;
   my $output;

   my $dir = qq~ <img src="$imgurl/dir.gif"> ~;

   if ($r_in->{'az'} eq 'list' or
         $r_in->{'az'} eq 'fully_threaded_list') {

      $output = qq~<a href="$boardurl"><font face="$r_setup->{'font_face_3'}"
         color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">Conferences</font></a>~;

      if ($r_setup->{'conf_listing'} eq 'on') {
         $output .= qq~ $dir <a 
			href="$boardurl?conf=$r_setup->{'forum_conf'}->{$r_in->{'forum'}}"><font face="$r_setup->{'font_face_3'}"
         color="$r_setup->{'font_color_3'}" 
         size="$r_setup->{'font_size_3'}">$r_setup->{'conf_name'}->{ $r_setup->{'forum_conf'}->{$r_in->{'forum'}} }</font></a> ~;
      }
      
      $output .= qq~$dir <font face="$r_setup->{'font_face_3'}"
         color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">$r_setup->{'forum_name'}->{$r_in->{'forum'}}</font>~;

   }
   elsif ($r_in->{'az'} eq 'lobby') {

      if ($r_in->{'conf'} ne '') {
         $output = qq~<a href="$boardurl"><font 
            face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">
            Conferences</font></a> $dir <font 
            face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}"> $r_setup->{'conf_name'}->{ $r_in->{'conf'} }</font>~;
      }
      else {
         $output = qq~<font size="$r_setup->{'font_size_3'}" 
            face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}">Conferences</font>~;   
      }
   }
   else {

      $output = qq~
      <a href="$boardurl"><font 
         face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">Conferences</font></a>
         $dir ~;

      if ($r_setup->{'conf_listing'} eq 'on') {

         $output .= qq~
         <a href="$boardurl?conf=$r_setup->{'forum_conf'}->{$r_in->{'forum'}}"><font 
         face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">
         $r_setup->{'conf_name'}->{ $r_setup->{'forum_conf'}->{$r_in->{'forum'}} }</font></a> $dir ~;
      }

      $output .= qq~
      <a href="$boardurl?az=list&forum=$r_in->{'forum'}&archive=$r_in->{'archive'}"><font 
         face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}" size="$r_setup->{'font_size_3'}">$r_setup->{'forum_name'}->{$r_in->{'forum'}}</FONT></a>
      $dir <font face="$r_setup->{'font_face_3'}" color="$r_setup->{'font_color_3'}"
      size="$r_setup->{'font_size_3'}">Topic #$r_in->{'om'}</FONT> ~;   

   }
   
   return $output;
}

#======================================================================#
# trim_text                                                            #
# takes input $text string and chops it off                            #
# the output is the first $text_length of $text                        #
#======================================================================#

sub trim_text {
   my ($text,$text_length) = @_;
   if (length($text) > $text_length) {
      $text = substr($text,0,$text_length);
      $text .= "...";
   }
   return $text;
}

#======================================================================#
# write_to_log                                                         #
# write user activity to the log file                                  #
#======================================================================#

sub write_to_log {
   my ($user,$action,$r_in) = @_;
   my $string;
   $string = join("$join_delim",$user,
      $action,$r_in->{'date'},$r_in->{'localtime'},$ENV{'REMOTE_ADDR'});
   appenddata("$password_file_dir/$logfile",$string);
}

#======================================================================#
# display_output                                                       #
# merge template and script data and print                             #
#======================================================================#

sub display_output {

   my ($templatefile,$r_namespace) = @_;
   my ($template);

   $| = 1;

   # Open template and read in

   open(TEMPLATE,"$templatefile") or 
       my_die ("Error in dcforumlib::display_output - Can't open $templatefile", $!);
   {
      local($/) = undef;
      $template = <TEMPLATE>;
   }
   close(TEMPLATE);
  
   $template =~ s/\$([A-Z]+)/$r_namespace->{$1}/g;

   print $template;

}


#======================================================================#
# check_datafile                                                       #
# checks to see if data file exists                                    #
#======================================================================#

sub check_datafile {

   my($datafile,$r_variables) = @_;

   unless (-e $datafile) {
      open(FILE,">$datafile") or
         my_die("Error in subroutine check_datafile: Can't open $datafile",$!);
      foreach (@{$r_variables}) {
         print FILE "$_\n";
      }
      close(FILE);
      chmod(0666,$datafile);
   }
}

#======================================================================#
# check_dir                                                            #
# checks a directory and creates it if it is empty                     #
#======================================================================#

sub check_dir {

   my $folder = shift;
   unless (-e $folder) {
      mkdir($folder,0777);
      chmod(0777,$folder);
   }
}

#======================================================================#
# remove_dir                                                           #
#======================================================================#

sub remove_dir {
   my $dir = shift;  
   opendir(D,"$dir") or
      my_die("Error in subroutine remove_dir: Can't open directory $dir",$!);
      while ($item = readdir(D)) {
         unlink("$dir/$item");
      }
   closedir(D);
   rmdir("$dir");
   
}


#======================================================================#
# my_crypt                                                             #
# if crypt causes error, use my_crypt                                  #
#======================================================================#

sub my_crypt {
   my ($arg1, $arg2) = @_;
   if (uc($platform) eq "FREEBSD") {
      $arg1 = crypt($arg1,substr($arg1,0,2));
   }
   elsif (uc($platform) eq "UNIX") {
      $arg1 = crypt($arg1,substr($arg2,0,2));
   }
   $arg1;
}

#======================================================================#
# subroutine send_mail
# REVISION
# 29 Dec 1998
#   Added Blatmail for NT servers
# 17 Mar 1998 - Version 1.0
#   First release
#
# NOTE:
#   Following variables are global
#   $r_setup->{'smtp_server'}
#
#======================================================================#

sub send_mail {

   my ($from,$to,$rec,$subject,$message,$r_setup) = @_;

	# NOTE: $r_setup contains some required parameters, namely:
   my $dir = $password_file_dir;
   my $mailprog = $r_setup->{'auth_sendmail_path'};
	my $smtp = $r_setup->{'auth_smtp_server'};
	my $use_blat = $r_setup->{'use_blat'};

   $subject =~ s/[\|\%\\]//g;

   unless (uc($platform) eq 'NT') {  
      open(MAIL,"|$mailprog -t") or
         my_die("Error in subroutine send_mail: Can't open $mailprog",$!);
      print MAIL "To: $to\n";
      print MAIL "From: $from\n";
      print MAIL "Reply-To: $rec\n";
      print MAIL "Subject: $subject\n\n";
      print MAIL "$message\n";
      close (MAIL);
   }
   else {
   
      if ($flag_status{$use_blat}) {
	      my (@output,$status);
	      my $temp_name = "temp_email";
	      my $temp_file = "$dir/$temp_name.txt";
	      $output[0] = $message;
	      writedata($temp_file,\@output);
	      $status = `$mailprog $temp_file -s \"$subject\" -f $from -t $to -server $smtp`;
	      unlink($temp_file);
      }
		else {
         
			# prepare mail message to send
			# Hack for Win NT and UNIX that opens a smtp socket
			# Hack submitted by
         my ($x,$here,$there,$thisserver,$remoteserver,$DATA_IN,$null);
         ($x,$x,$x,$x, $here) = gethostbyname($null);
         ($x,$x,$x,$x, $there) = gethostbyname($smtp);
         $thisserver = pack('S n a4 x8',2,0,$here);
         $remoteserver = pack('S n a4 x8',2,25,$there);
         (!(socket(S,2,1,6))) && (my_die("Sending Email: Connect error! socket",$!));
         (!(bind(S,$thisserver))) && (my_die("Sending Email: Connect error! bind",$!));
         (!(connect(S,$remoteserver))) && (my_die("Sending Email: Connection to $smtp has failed ",$!));

         select(S);
         $| = 1;
         select(STDOUT);

         $DATA_IN = <S>;
         ($DATA_IN !~ /^220/) && (my_die("Sending Email: data in Connect error - 220",$!)); 

         print S "HELO $smtp\r\n";
         $DATA_IN = <S>;
         ($DATA_IN !~ /^250/) && (my_die("Sending Email: data in Connect error - 250",$!)); 

         print S "MAIL FROM:<$from>\r\n";
         $DATA_IN = <S>;
         ($DATA_IN !~ /^250/) && (my_die("Sending Email: 'From' address not valid",$!)); 

         print S "RCPT TO:<$to>\r\n";
         $DATA_IN = <S>;
         ($DATA_IN !~ /^250/) && (my_die("Sending Email: 'Recipient' address not valid",$!)); 

         print S "DATA\r\n";
         $DATA_IN = <S>;
         ($DATA_IN !~ /^354/) && (my_die("Sending Email: Message send failed - 354",$!)); 

         print S "From: $from\r\n";
         print S "To: $to\r\n";
         print S "Reply-To: $rec\r\n";
         print S "Subject: $subject\r\n\r\n";
         print S "$message\r\n";
         print S ".\r\n";

        $DATA_IN = <S>;
        ($DATA_IN !~ /^250/) && (my_die("Sending Email: Message send failed - try again - 250",$!)); 
        print S "QUIT\r\n";

	   }

   }

}

#======================================================================#
# subroutine sendCookie
# Sends HTTP-COOKIE to the client
#======================================================================#

sub send_cookie {

  my ($key,$value,$expires,$domain) = @_;

  if ($expires ne "") {
      print "Set-Cookie: $key=$value; expires=$expires; path=/; \n";
   }
   else {
      print "Set-Cookie: $key=$value; path=/; \n";
   }
}

#======================================================================#
# subroutine get_cookie
# Get cookie from the client
# Cookie's name is $cookie
#======================================================================#

sub get_cookie {

  my ($cookie) = shift;
  my (@key_value_pairs, $key, $value);
  @key_value_pairs = split (/;\s/, $ENV{'HTTP_COOKIE'});

  foreach (@key_value_pairs) {
    ($key,$value) = split (/=/, $_);
    if ($key eq $cookie) {
      return $value;
    }
  }
  return 0;
}

# add_antispam no longer used
# remove_antispam no longer used
#======================================================================#
# subroutine compute_time
# returns time marker for keeping
# track of messages read
#======================================================================#

# Use jday for a better compute time
sub compute_time {

   my ($year, $month, $day, $hour, $minute, $second) = @_;

   $year += 1900 if ($year < 1000);

   # In julian date
   my $jday = jday($month,$day,$year);

#   my $mesg_mark = (($year - 1997) * 372 * 86400) +
#            ($month * 31 * 86400) + ($day * 86400) +
#            ($hour * 3600) + ($minute * 60) + $second;

   my $mesg_mark = ($jday * 86400) +
            ($hour * 3600) + ($minute * 60) + $second;

   return $mesg_mark;
}

#======================================================================#
# subroutine get_date
# modified to work with dcboard
#======================================================================#

sub get_date {

   my ($r_in) = @_;
   my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time+3600*$r_setup->{'time_offset'});
   $year += 1900;

   $mon++;

   my $jday = jday($mon,$mday,$year);

   $r_in->{'last_read'} = ($jday - $r_in->{'days'})*86400
       + ($hour * 3600) + ($min * 60) + $sec;

   $r_in->{'time_now'} = $jday*86400
       + ($hour * 3600) + ($min * 60) + $sec;

#   $r_in->{'last_read'} = (($year - 1997) * 372 * 86400) +
#      ($mon * 31 * 86400) + (($mday - $r_in->{'days'}) * 86400)
#       + ($hour * 3600) + ($min * 60) + $sec;

#   $r_in->{'time_now'} = (($year - 1997) * 372 * 86400) +
#      ($mon * 31 * 86400) + ($mday * 86400)
#       + ($hour * 3600) + ($min * 60) + $sec;

   my $month = $months[$mon - 1];

   # Format to look nice
   $sec = sprintf("%02d",$sec);
   $min = sprintf("%02d",$min);
   $hour = sprintf("%02d",$hour);
   $mon = sprintf("%02d",$mon);
   $mday = sprintf("%02d",$mday);

   # For displaying dates etc
   $r_in->{'localtime'} = "$hour\:$min\:$sec";
   $r_in->{'date'} = "$mon/$mday/$year";
   # For computing times

}

#======================================================================#
# subroutine my_die
#======================================================================#

sub my_die {

   my($my_mesg, $sys_mesg) = @_;
   print_header();
   print_header_end();

   # don't print the my_mesg as it can give away
   # directory structure
   print qq~
   <html><head>
   <title>Request Error</title></head>
   <body bgcolor="#FFFFFF">
   <font face="verdana" size="5"><b>SCRIPT ERROR!!!</b></font>
   <hr>
   <font face="verdana" size="3">
   <b>
   There was an error in processing your request.<br>
   Following is the error message:
   <ul>
   <li>System Message: $sys_mesg
   </ul>
   <hr>Please notify the administrator of this site.
   <p>Thank you.
   </b></font></body></html>~;

   exit;       

}

#======================================================================#
# Subroutine get_session_id
# Generates session ID for a User.
# This portion of code from Selena and Gunther's
# auth-extra-lib.pl
#======================================================================#

sub get_session_id {

   my ($session, $session_file);

   # Seed the random generator

   srand($$|time);
   $session = int(rand(60000));

   # pack the time, process id, and random $session into a
   # hex number which will make up the session id.

   $session = unpack("H*", pack("Nnn", time, $$, $session));

} # End of get_session_id

#======================================================================#
# function time_format
#======================================================================#

sub time_format {
   my ($string) = shift;
   my ($hr,$min,$sec) = split(/\:/,$string);
   ($hr,$am_pm) = am_pm($hr);
   $string = join(":",$hr,$min);
   $string .= "&nbsp;" . $am_pm;
   return $string;
}

#======================================================================#
# function date_format
#======================================================================#

sub date_format {
   my ($string) = shift;
   my @months = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
   my ($mon,$day,$year) = split(/\//,$string);
   if ($year > 100) {
      $year = substr($year,2,2);
   }
   if ($r_setup->{'date_format'} eq "mmm-dd-yy") {
      $string = join("-",$months[$mon-1],$day,$year);
   }
   elsif ($r_setup->{'date_format'} eq "dd-mmm-yy") {
      $string = join("-",$day,$months[$mon-1],$year);
   }
   elsif ($r_setup->{'date_format'} eq "dd-mm-yy") {
      $string = join("-",$day,$mon,$year);
   }
   elsif ($r_setup->{'date_format'} eq "mm-dd-yy") {
      $string = join("-",$mon,$day,$year);
   }

   return $string;
}

#======================================================================#
# function am_pm
# given hour, print am or pm
#======================================================================#

sub am_pm {
   my ($hour) = shift;
   my $am_pm = 'AM';
   
   if ($hour > 12) {
      $hour -= 12;
      $am_pm = 'PM';
   }
   elsif ($hour == 12) {
      $am_pm = 'PM';
   }

   $hour = sprintf("%02d",$hour);
   return ($hour,$am_pm);
}

#======================================================================#
# function toggle_color
# for switching back and forth...
#======================================================================#

# Added second color return $bgcolort
sub toggle_color {

   my $reset = shift;

   unless ($reset) {
      if ($bgcolor eq $r_setup->{'bg_color_1'}) {
         $bgcolor = $r_setup->{'bg_color_2'};
         $bgcolort = $r_setup->{'bg_color_1'};
         $font_color = $r_setup->{'font_color_2'};
         $font_face = $r_setup->{'font_face_2'};
         $font_size = $r_setup->{'font_size_2'};
      }
      else {
         $bgcolor = $r_setup->{'bg_color_1'};
         $bgcolort = $r_setup->{'bg_color_2'};
         $font_color = $r_setup->{'font_color_1'};
         $font_face = $r_setup->{'font_face_1'};
         $font_size = $r_setup->{'font_size_1'};
      }
   }
   else {
      $bgcolor = $r_setup->{'bg_color_1'};
      $bgcolort = $r_setup->{'bg_color_2'};
      $font_color = $r_setup->{'font_color_1'};
      $font_face = $r_setup->{'font_face_1'};
      $font_size = $r_setup->{'font_size_1'};
   }
}

#======================================================================#
# function print_header
# print HTTP header if not printed yet
#======================================================================#

sub print_header {
   unless ($print_header) {
      print "Content-type: text/html\n";
      $print_header = 1;
   }
   return 0;
}

#======================================================================#
# function print_header_end
# print end of HTTP header if not printed yet
#======================================================================#

sub print_header_end {
   unless ($print_header_end) {
      print "\n";
      $print_header_end = 1;
   }
   return 0;
}

#======================================================================#
# function dc_decode
# decode encoded string
#======================================================================#

sub dc_decode {
    my $todecode = shift;
    return undef unless defined($todecode);
    $todecode =~ tr/+/ /;       # pluses become spaces
    $todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
    $todecode =~ s/\r\n/\n/g;;
    return $todecode;
}

#======================================================================#
# function dc_encode
# encode string
#======================================================================#

sub dc_encode {
    my $toencode = shift;
    return undef unless defined($toencode);
    $toencode =~ s/([^a-zA-Z0-9_. -])/uc sprintf("%%%02x",ord($1))/eg;
    return $toencode;
}


#===============================================================#
# function form_to_text                                         #
# translates form data to text database format                  #
#===============================================================#

sub form_to_text {
   my $text = shift;
   $text =~ s/"/\&quot\;/g;
   $text =~ s/</\&lt\;/g;
   $text =~ s/\n\n/\[P\]/g;
   $text =~ s/\r\n/\[BR\]/g;
   $text =~ s/\n/\[BR\]/g;
   $text =~ s/\cM//g;
   return $text;
}

#===============================================================#
# function text_to_form                                         #
# translates text data to form data format                      #
#===============================================================#

sub text_to_form {
   my $text = shift;
   $text =~ s/\&quot\;/"/g;
   $text =~ s/\[P\]/\n\n/gi;
   $text =~ s/\[BR\]/\n/gi;
   return $text;
}

#======================================================================#
# get_userdata                                                         #
# Gets user data from the session file                                 #
#======================================================================#

sub get_userdata {

   my $session_file = shift;
   my $r_data = readdata($session_file);
   my $r_local = {};
   foreach (@{$r_data}) {
      chomp;
      ($key,$value) = split(/::/,$_);
      $r_local->{$key} = $value;
   }
   return $r_local;

}

#===============================================================#
# sub get_user_email
# given username, it retrieve the user email
#===============================================================#
# mod.2001.06.13.01
# More effcient way to retrieve user data

sub get_user_email {

   my $user = shift;

# mod.2001.06.13.01
# More effcient way to retrieve user data
# Get it from User_email directory

   $user = url_encode($user);
   if (-e "$user_email_dir/$user.txt") {
      open(ED,"$user_email_dir/$user.txt") 
         or my_die("Error in function get_user_email: Can't open $user_email_dir/$user.txt",$!);
      my $email = <ED>;
      close(ED);
      chomp($email);
      return $email;
   }
   else {
      return 0;
   }

}

#======================================================================#
# is_moderator                                                         #
# Returns 1 if $user is a moderator                                    #
# Returns 0 otherwise                                                  #
#======================================================================#

sub is_moderator {
	my ($user, $owners) = @_;
	my @owners = split(",",$owners);
	my $flag = 0;
	foreach (@owners) {
		if ($user eq $_) {
			$flag=1;
			last;
		}
	}
	return $flag;
}

# mod.2000.05.23.02
#####
# subroutine readdata
# Sucks in all the data from $datafile
# and returns reference to the data
####

sub readdata {

   my $datafile = shift;
   my $r_data = [];

	# Remove strange characters
   # This is done in check_form_input
#	$datafile =~ s/[\||\;\<\>]//g;

   # Get file lock
   lock_file("$datafile");

   if (open(RDATA,"$datafile")) {
   	@{$r_data} = <RDATA>;
	   close(RDATA);
		unlock_file("$datafile");
	}
	else {
  		unlock_file("$datafile");
		my_die("Error in subroutine readdata: Can't open $datafile",$!);
	}

   return $r_data;

}

# mod.2000.05.23.02
#####
# subroutine writedata
#####

sub writedata {

   my($datafile,$r_rows) = @_;

	# Remove strange characters
#	$datafile =~ s/[\||\;\<\>]//g;

   lock_file("$datafile");

   if (open(WDATA,">$datafile")) {
      print WDATA @{$r_rows};
      close(WDATA);
	   chmod(0666,$datafile);
      unlock_file("$datafile");
   }
   else {
      unlock_file("$datafile");
      my_die("Error in subroutine writedata: Can't open $datafile",$!);
   }

}

# mod.2000.05.23.02
#####
#
# subroutine appenddata
#
#
#####

sub appenddata {

   my($datafile,$row) = @_;

	# Remove strange characters
#	$datafile =~ s/[\||\;\<\>]//g;

   lock_file("$datafile");

   if (open(ADATA,">>$datafile")) {
      print ADATA "$row\n";
      close(ADATA);
      unlock_file("$datafile");
   }
   else {
      unlock_file("$datafile");
      my_die("Error in subroutine appenddata: Can't open $datafile",$!);
   }
}

# mod.2000.05.23.02
#####
#
# function lock_file
#
# This filelock function is based on Selena Sol's AuthGetFileLock
# The problem with Sol's file lock system is that, at times, the
# file lock would persist, causing the system to pause indifinitely.
# This new function should eliminate this problem
#
#####


sub lock_file {  

    my $lock_file = shift;
	 my $flag = 1;
    my $count = 0;
    my $lock_time = 2;  # in 5 second increments
                        # total wait time 5*$lock_time seconds

    $lock_file .= ".lock";

    # check_flock will pause for 1 seconds
    # if the lock file persists for 30 seconds
    # then this routine will delete the lock file
    # and then move on.

    while($flag and $count < $lock_time) {
		$flag = check_flock($lock_file);
      $count++;
    }

    # Did you wait more than 3*$lock_time seconds? 
	 # If so, probably an old lock file.
    # Delete lock file and proceed
    unlink($lock_file) if ($count == $lock_time);

    open(LOCK_FILE, ">$lock_file");
       print LOCK_FILE 'DC';
    close(LOCK_FILE);

    return 1;

}


# mod.2000.05.23.02
######
#
# Function unlock_file
#
#####

sub unlock_file {
    my ($lock_file) = @_;
    $lock_file .= ".lock";
    unlink($lock_file) if (-e $lock_file);
    return 1;
}

# mod.2000.05.23.02
####
# function check_flock
# This function checks to see if a file exists
# If it exists, it pauses 5 seconds and the returns 1.
# Otherwise, it returns a 0.
#
# Only one function uses this function - lock_file
#
####

sub check_flock {

   my ($file) = shift;
   if (-e $file) {
      sleep (5);
      return 1;
   }
   else {
      return 0;
   }
}


# mod.2000.05.23.01
#-----------------------------------------------------------------
# contents of cgi-lib.pl
# Perl Routines to Manipulate CGI input
# cgi-lib@pobox.com
# $Id: cgi-lib.pl,v 2.18 1999/02/23 08:16:43 brenner Exp $
#
# Copyright (c) 1993-1999 Steven E. Brenner  
# Unpublished work.
# Permission granted to use and modify this library so long as the
# copyright above is maintained, modifications are documented, and
# credit is given for any use of the library.
#
# Thanks are due to many people for reporting bugs and suggestions

# For more information, see:
#     http://cgi-lib.stanford.edu/cgi-lib/

$cgi_lib'version = sprintf("%d.%02d", q$Revision: 2.18 $ =~ /(\d+)\.(\d+)/);


# Parameters affecting cgi-lib behavior
# User-configurable parameters affecting file upload.
$cgi_lib'maxdata    = 131072;    # maximum bytes to accept via POST - 2^17
$cgi_lib'writefiles =      0;    # directory to which to write files, or
                                 # 0 if files should not be written
$cgi_lib'filepre    = "cgi-lib"; # Prefix of file names, in directory above

# Do not change the following parameters unless you have special reasons
$cgi_lib'bufsize  =  8192;    # default buffer size when reading multipart
$cgi_lib'maxbound =   100;    # maximum boundary length to be encounterd
$cgi_lib'headerout =    0;    # indicates whether the header has been printed


# ReadParse
# Reads in GET or POST data, converts it to unescaped text, and puts
# key/value pairs in %in, using "\0" to separate multiple selections

# Returns >0 if there was input, 0 if there was no input 
# undef indicates some failure.

# Now that cgi scripts can be put in the normal file space, it is useful
# to combine both the form and the script in one place.  If no parameters
# are given (i.e., ReadParse returns FALSE), then a form could be output.

# If a reference to a hash is given, then the data will be stored in that
# hash, but the data from $in and @in will become inaccessable.
# If a variable-glob (e.g., *cgi_input) is the first parameter to ReadParse,
# information is stored there, rather than in $in, @in, and %in.
# Second, third, and fourth parameters fill associative arrays analagous to
# %in with data relevant to file uploads. 

# If no method is given, the script will process both command-line arguments
# of the form: name=value and any text that is in $ENV{'QUERY_STRING'}
# This is intended to aid debugging and may be changed in future releases

sub ReadParse {
  # Disable warnings as this code deliberately uses local and environment
  # variables which are preset to undef (i.e., not explicitly initialized)
  local ($perlwarn);
  $perlwarn = $^W;
  $^W = 0;

  local (*in) = shift if @_;    # CGI input
  local (*incfn,                # Client's filename (may not be provided)
	 *inct,                 # Client's content-type (may not be provided)
	 *insfn) = @_;          # Server's filename (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $got, $name);
	
  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else 
  binmode(STDERR);
	
  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};
  
  if ($len > $cgi_lib'maxdata) { #'
      my_die("cgi-lib.pl: Request to receive too much data: $len bytes\n",$!);
  }
  
  if (!defined $meth || $meth eq '' || $meth eq 'GET' || 
      $meth eq 'HEAD' ||
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);
	
    # Read in text
    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $in, $len) != $len))
	  {$errflag="Short Read: wanted $len, got $got\n";};
    } else {
      my_die("cgi-lib.pl: Unknown request method: $meth\n",$!);
    }

    @in = split(/[&;]/,$in); 
    push(@in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.  
      ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
$errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) = 
      ($cgi_lib'bufsize, $cgi_lib'maxbound, $cgi_lib'writefiles);


    # The following lines exist solely to eliminate spurious warning messages
    $buf = ''; 

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    my_die("Boundary not provided: probably a bug in your server",$!) 
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      my_die("Invalid request method for  multipart/form-data: $meth\n",$!);
    }

    if ($writefiles) {
      local($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib'filepre"; 
    }

    # read in the data and split into parts:
    # put headers in @in and data in %in
    # General algorithm:
    #   There are two dividers: the border and the '\r\n\r\n' between
    # header and body.  Iterate between searching for these
    #   Retain a buffer of size(bufsize+maxbound); the latter part is
    # to ensure that dividers don't get lost by wrapping between two bufs
    #   Look for a divider in the current batch.  If not found, then
    # save all of bufsize, move the maxbound extra buffer to the front of
    # the buffer, and read in a new bufsize bytes.  If a divider is found,
    # save everything up to the divider.  Then empty the buffer of everything
    # up to the end of the divider.  Refill buffer to bufsize+maxbound
    #   Note slightly odd organization.  Code before BODY: really goes with
    # code following HEAD:, but is put first to 'pre-fill' buffers.  BODY:
    # is placed before HEAD: because we first need to discard any 'preface,'
    # which would be analagous to a body without a preceeding head.

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name}; 
      $in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1}; 
        $insfn{$1} .= $fn if $fn;
      }
 
     BODY: 
      while (($bpos = index($buf, $boundary)) == -1) {
        if ($left == 0 && $buf eq '') {
	  foreach $value (values %insfn) {
            unlink(split("\0",$value));
	  }
	  my_die("cgi-lib.pl: reached end of input while seeking boundary " .
		  "of multipart. Format of CGI input is wrong.\n",$!);
        }
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          else     { $in{$name} .= substr($buf, 0, $bufsize); }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
	die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        else     { $in {$name} .= substr($buf, 0, $bpos-2); } # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 2) eq "--";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;


      undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
        if ($left == 0  && $buf eq '') {
	  foreach $value (values %insfn) {
            unlink(split("\0",$value));
	  }
	  my_die("cgi-lib: reached end of input while seeking end of " .
		  "headers. Format of CGI input is wrong.\n$buf",$!);
        }
        die $@ if $errflag;
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);
      push (@in, $head);
      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") . 
        (defined $fname ? $fname : "");

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
	$fn = $writefiles . ".$$.$ser";
	open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';
      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      local ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %insfn) {
        unlink(split("\0",$value));
      }
      my_die($errmsg,$!);
    } else {
      # everything's ok.
    }
  } else {
    my_die("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n",$!);
  }

  # no-ops to avoid warnings
  $insfn = $insfn;
  $incfn = $incfn;
  $inct  = $inct;

  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@in)); 
}


# SplitParam
# Splits a multi-valued parameter into a list of the constituent parameters

sub SplitParam
{
  local ($param) = @_;
  local (@params) = split ("\0", $param);
  return (wantarray ? @params : $params[0]);
}


# The following lines exist only to avoid warning messages
$cgi_lib'writefiles =  $cgi_lib'writefiles;
$cgi_lib'bufsize    =  $cgi_lib'bufsize ;
$cgi_lib'maxbound   =  $cgi_lib'maxbound;
$cgi_lib'version    =  $cgi_lib'version;
$cgi_lib'filepre    =  $cgi_lib'filepre;

# mod.2000.05.24.01
#======================================================================#
# function url_encode
# url encode string
# NOTE - the only difference between dc_encode and url_encode
# is that dc_encode do not encode blank spaces
#======================================================================#

sub url_encode {
    my $toencode = shift;
    return undef unless defined($toencode);
    $toencode =~ s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
    return $toencode;
}

#======================================================================#
# function url_decode
# decode encoded string
#======================================================================#

sub url_decode {
    my $todecode = shift;
    return undef unless defined($todecode);
    $todecode =~ tr/+/ /;       # pluses become spaces
    $todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
    return $todecode;
}


###
# function check_email
# moved from email_notification.pl
###
# mod.2000.10.04.01 - Email to moderators for moderated forum

sub check_email {

   my ($email) = shift;
    if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/ || 
        ($email !~ /^.+\@localhost$/ && 
         $email !~ /^.+\@\[?(\w|[-.])+\.[a-zA-Z]{2,3}|[0-9]{1,3}\]?$/)) {
        return(0);
    }    
    else {
        return(1);
    }
}

#############################################################################
# function private
# returns 1 if function type is Private or Restricted
#############################################################################

sub private {
   my $forum_type = shift;
   if ($forum_type eq 'Private' or
       $forum_type eq 'Restricted') {
       return 1;
   }
   else {
      return 0;
   }
}

#############################################################################
# function js_text
# returns Javascript text for conditional link text
#############################################################################

sub js_text {
  my $text = shift;
  $text = qq~
   <SCRIPT>
      var cookie_name = '$cookie_name';
      if (check_cookie(cookie_name)) \{
         document.write('$text');
      \}
   </script>
   ~;
   return $text;
}

####################################################################
# function conf_forum_tree
# return a hash reference that contains the
# tree structure of forums as a function of conferences
# added on 07/12/2001
####################################################################

sub conf_forum_tree {
   my ($r_in,$r_setup) = @_;
   my $r_conf_forums = {};
   # Build list of forums in a conference
   foreach (@{$r_setup->{'forums'}}) {
      if ($flag_status{$r_setup->{'forum_status'}->{$_}} and 
         check_forum_access($r_in,$r_setup,$_) ) {
         # Hmmm, for sitemap, do we need to check for conf?
         if ($r_in->{'conf'}) {
            if ($r_in->{'conf'} eq $r_setup->{'forum_conf'}->{$_}) {
               push( @{ $r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} } , $_);
            }
         }
         else {
            push( @{ $r_conf_forums->{$r_setup->{'forum_conf'}->{$_}} } , $_);
         }
      }
   }
   return $r_conf_forums;
}

################################################################
# function sub_heading
# return sub heading style of text
################################################################

sub sub_heading {
   my ($text,$r_setup) = @_;
   $text = qq~<p align="center"><font size="3" 
   face="$r_setup->{'font_face_4'}" color="$r_setup->{'font_color_4'}"><b>$text</b></font></p>~;
   return $text;
}

################################################################
# mod.2001.04.01.01
# Additional security hack
################################################################
# check_form_input
# Make sure no metacharacters are used in user input
# Only allow expected characters
#################################################################

sub check_form_input {

   my $r_in = shift;
   
   # mod.2001.03.30.01 security patch
   # parameter az should only be alphanumeric characters
   # remove all other characters
   if ($r_in->{'az'}) {
      $r_in->{'az'} =~ s/\W//g;
   }

   # mod.2000.11.14.01 security patch
   # parameter forum should only be alphanumeric characters
   # remove all other characters
   if ($r_in->{'forum'}) {
      $r_in->{'forum'} =~ s/\W//g;
   }

   # ditto for forum too
   if ($r_in->{'s_forum'}) {
      $r_in->{'s_forum'} =~ s/\W//g;
   }

   # parameter conf should only be alphanumeric characters
   if ($r_in->{'conf'}) {
      $r_in->{'conf'} =~ s/\W//g;
   }

   # parameter command should only be alphanumeric characters
   if ($r_in->{'command'}) {
      $r_in->{'command'} =~ s/\W//g;
   }

   # parameter command should only be alphanumeric characters
   if ($r_in->{'sub_command'}) {
      $r_in->{'sub_command'} =~ s/\W//g;
   }

   # parameter command should only be alphanumeric characters
   if ($r_in->{'quote'}) {
      $r_in->{'quote'} =~ s/\W//g;
   }

   # parameter om should only be numeric characters
   if ($r_in->{'om'}) {
      $r_in->{'om'} =~ s/\D//g;
   }

   # parameter omm should only be alphanumeric characters
   if ($r_in->{'omm'}) {
      $r_in->{'omm'} =~ s/\D//g;
   }

   # parameter mark should only be alphanumeric characters
   if ($r_in->{'mark'}) {
      $r_in->{'mark'} =~ s/\D//g;
   }

   # parameter mark should only be alphanumeric characters
   if ($r_in->{'mode'}) {
      $r_in->{'mode'} =~ s/\W//g;
   }

   # mod.2001.06.20.01
   # parameter omm should only be alphanumeric characters
   if ($r_in->{'page_num'}) {
      $r_in->{'page_num'} =~ s/\D//g;
   }

   return $r_in;

}


###############################################################
# Function remove_junk
# mod.2001.04.07.01
# Temp fix for getting rid of all HTML tags
# in subject - will revisit this in 6.2
###############################################################

sub remove_junk {
   my $text = shift;
   $text =~ s/\[\s*\/?(script|object|embed|applet|form|input|\n)[^\]]*\]//gi; 
   $text =~ s/\<\s*\/?(script|object|embed|applet|form|input|\n)[^\]]*\>//gi; 
   $text =~ s/\[([^\]]|\n)*\]//gi;
   $text =~ s/\<([^\>]|\n)*\>//gi;
   $text =~ s/\<//gi;
   $text =~ s/\>//gi;
   return $text;
}


1;
